From 6bdfa5b40539a10d1a43b2d4c68c79e8bf7879bd Mon Sep 17 00:00:00 2001
From: Andres Freund <andres@anarazel.de>
Date: Tue, 10 Mar 2026 13:14:37 -0400
Subject: [PATCH v12a 3/4] Replace Latches with Interrupts

The Latch was a flag, with an inter-process signalling mechanism that
allowed a process to wait for the Latch to be set. My original vision
for Latches was that you could have different latches for different
things that you need to wait for, but in practice, almost all code
used one "process latch" that was shared for all wakeups. The only
exception was the "recoveryWakeupLatch". I think the reason that we
ended up just sharing the same latch for all wakeups is that it was
cumbersome in practice to deal with multiple latches. For starters,
there was no machinery for waiting for multiple latches at the same
time. Secondly, changing the "ownership" of a latch needed extra
locking or other coordination. Thirdly, each inter-process latch
needed to be initialized at postmaster startup time.

This patch embraces the reality of how Latches were used, and replaces
the Latches with a per-process interrupt mask. You can no longer
allocate Latches in arbitrary shared memory structs and an interrupt
is always directed at a particular process, addressed by its
ProcNumber. Each process has a bitmask of pending interrupts in
PGPROC.

This replaces ProcSignals and many direct uses of Unix signals with
interrupts. For example, the backend-private ProcDiePending flag is
replaced with the INTERRUPT_TERMINATE interrupt. SIGTERM can still be
used to raise it, but the default SIGTERM signal handler now just
raises INTERRUPT_TERMINATE.

Handling interrupts
-------------------

To control which interrupts can be processed at what time, there are a
few mechanisms. Firstly, you can register a handler function for each
interrupt, which will be called from CHECK_FOR_INTERRUPTS() if the
interrupt is pending. After this commit, ProcessInterrupts() has no
knowledge about the meaning of the different interrupts, it just calls
the registered callback functions. Different procesess can set up
different handlers, according to their needs, but some commonly used
handlers are provided and installed during backend startup.

In addition to CHECK_FOR_INTERRUPTS(), you can also check whether a
particular interrupt is pending and handle it yourself.

Most callers of WaitInterrupt (which replaces WaitLatch) use
CheckForInterruptMask, which is a bitmask that includes all the
interrupts that are handled by CHECK_FOR_INTERRUPTS() in the current
state. CHECK_FOR_INTERRUPTS() clears the interrupts bits that it
processes, the caller is no longer required to do ClearInterrupt (or
ResetLatch) for those bits. If you wake up for other interrupts that
are not handled by CHECK_FOR_INTERRUPTS(), you still need to clear
those.

Now that there are separate bits for different things, it's possible
to do e.g. WaitInterrupt(INTERRUPT_CONFIG_RELOAD |
INTERRUPT_QUERY_CANCEL) to wait just for a config reload request or
query cancellation, and not wake up on other events like a shutdown
request. That's not very useful in practice, as CHECK_FOR_INTERRUPTS()
still processes those interrupts if you call it, and you would want to
process all the standard interrupts promptly anyway. It might be
useful to check for specific interrupts with InterruptPending(),
without immediately processing them, however. spgdoinsert() does
something like that. In this commit I didn't change its overall logic,
but it probably could be made more fine-grained now.

More importantly, you can now have additional interrupts that are
processed less frequently and do not wake up the backend when it's not
prepared to process them. For example, the SINVAL_CATCHUP interrupt is
only processed when the backend is idle. Previously, a catchup request
would wake up the process whether it was ready to handle it or not;
now it only wakes up when the backend is idle. That's not too
significant for catchup interrupts because they don't occur that often
anyway, but it's still nice and could be more significant with other
interrupts.

There's still a general-purpose INTERRUPT_WAIT_WAKEUP interrupt that
is multiplexed for many different purposes in different processes, for
example to wake up the walwriter when it has work to do, and to wake
up processes waiting on a condition variable. The common property of
those uses is that there's some other flag or condition that is
checked on each wakeup, the wakeup interrupt itself means merely that
something interesting might've happened.

Replacing recoveryWakeupLatch
-----------------------------

The INTERRUPT_RECOVERY_CONTINUE replaces recoveryWakeupLatch. With
this new interface, the startup process can easily wait for the common
interrupts at the same time as INTERRUPT_RECOVERY_CONTINUE.
Previously, the code that waited on recoveryWakeupLatch had to resort
to timeouts to react to other signals, because it was not possible to
wait for two latches at the same time. Previous attempt at unifying
those wakeups was in commit ac22929a26, but it was reverted in commit
00f690a239 because it caused a lot of spurious wakeups when the
startup process was waiting for recovery conflicts. The new machinery
avoids that problem by making it easy to wait for two interrupts at
the same time.

Fix lost wakeup issue in logical replication launcher
-----------------------------------------------------

Similarly there's now a dedicated interrupt bit to notify the logical
replication launcher about subscription changes. That fixes the lost wakeup issue discussed at:
  Discussion: https://www.postgresql.org/message-id/476672e7-62f1-4cab-a822-f3a8e949dd3f@iki.fi
  Discussion: https://www.postgresql.org/message-id/ff0663d9-8011-420f-a169-efbf57327cb5@iki.fi

Background worker state change notification
-------------------------------------------

INTERRUPT_WAIT_WAKEUP is used for bgworker state change notification.
As part of a project to remove the reliance on PIDs to identify
backends, backends that register dynamic background workers will now
receive INTERRUPT_WAIT_WAKEUP sent directly by the postmaster when the
worker state changes.  Previously, the postmaster would send a SIGUSR1
signal, which relied on the ProcSignal system's handler setting the
interrupt flag, with the same end effect.  Now that intermediate step
is skipped.

The field bgw_notify_pid still exists for backwards compatibility, but
has no effect and may be removed in a later release.
RegisterBackgroundWorker() now automatically assumes that the caller
would like state change notifications delivered to its proc number,
unless BGW_NO_NOTIFY is set in bgw_flags.

Removing other cases of PIDs from the bgworker API is left for later
work; this patch is concerned only with removing a dependency on
ProcSignal infrastructure that is due to be removed by a later commit.

XXX: original text from Thomas's patch
--------------------------------------

"ProcSignals" were a two-step way for one backend to ask another backend
to do something, by multiplexing SIGUSR1.  Historically, real work was
done in the SIGUSR1 handler, but commit 0da096d7 removed the last case
of that.  Now the handler just set "interrupt pending" flags, called
SetLatch(MyLatch) to close races, and then did all the interesting work
at the next CHECK_FOR_INTERRUPTS() call.

This commit removes the ProcSignal step, replacing ProcSignals with
Interrupts.

Benefits of this refactoring include removing unnecessary concepts and
terminology, avoiding the risk of people putting buggy code back into
signal handlers, removing a whole lot of global variables, removing
dependencies on PIDs and the process model, removing risks of sending
a signal that has default action of termination to the wrong process,
and taking a step towards being able remove the fake signal system
from the Windows port.

Notable changes:

 * all calls to SendProcSignal(pid, PROCSIG_XXX) become
   SendInterrupt(INTERRUPT_XXX, procno)
 * all XxxPending global variables are gone; they are represented
   as bits in MyProc->pending_interrupts
 * the SIGUSR1 handler is gone
 * places that know the PIDs of other backends must now use procnos
   instead

The only code left in src/backend/storage/ipc/procsignal.c relates to
ProcSignalBarriers.  XXX Those should perhaps be renamed.

SIGUSR1 can now be set to SIG_IGN in most backends.  Some special cases
remain, that were not using the general sigusr1_handler (now removed).
---
 src/include/Makefile                          |   1 +
 src/include/access/parallel.h                 |   2 -
 src/include/access/xlogrecovery.h             |  18 -
 src/include/commands/async.h                  |   6 -
 src/include/ipc/interrupt.h                   | 370 +++++++++++
 .../interrupt.h => ipc/signal_handlers.h}     |   6 +-
 src/include/libpq/libpq-be-fe-helpers.h       |  48 +-
 src/include/libpq/libpq.h                     |   2 +-
 src/include/libpq/pqmq.h                      |   2 +-
 src/include/meson.build                       |   1 +
 src/include/miscadmin.h                       | 135 +---
 src/include/postmaster/bgworker.h             |  10 +-
 src/include/postmaster/bgworker_internals.h   |   4 +-
 src/include/postmaster/startup.h              |   4 +-
 src/include/replication/logicalworker.h       |   5 -
 src/include/replication/walsender.h           |   1 -
 src/include/replication/walsender_private.h   |   2 +
 src/include/replication/worker_internal.h     |   5 +-
 src/include/storage/proc.h                    |  16 +-
 src/include/storage/procarray.h               |   2 +-
 src/include/storage/procsignal.h              |  33 -
 src/include/storage/sinval.h                  |   5 -
 src/include/storage/waiteventset.h            |  39 +-
 src/include/tcop/tcopprot.h                   |   7 -
 src/include/utils/memutils.h                  |   1 -
 src/include/utils/pgstat_internal.h           |   1 +
 src/common/scram-common.c                     |   2 +-
 src/port/pg_numa.c                            |   5 +-
 src/port/pgsleep.c                            |   8 +-
 src/backend/Makefile                          |   1 +
 src/backend/access/brin/brin_pageops.c        |   2 +-
 src/backend/access/brin/brin_revmap.c         |   2 +-
 src/backend/access/common/toast_internals.c   |   2 +-
 src/backend/access/gin/ginbtree.c             |   2 +-
 src/backend/access/gin/gindatapage.c          |   2 +-
 src/backend/access/gin/ginfast.c              |   1 +
 src/backend/access/gin/ginget.c               |   1 +
 src/backend/access/gin/ginutil.c              |   2 +-
 src/backend/access/gin/ginvacuum.c            |   1 +
 src/backend/access/gist/gist.c                |   1 +
 src/backend/access/gist/gistget.c             |   2 +-
 src/backend/access/gist/gistvacuum.c          |   2 +-
 src/backend/access/hash/hash.c                |   2 +-
 src/backend/access/hash/hashinsert.c          |   2 +-
 src/backend/access/hash/hashovfl.c            |   2 +-
 src/backend/access/hash/hashpage.c            |   2 +-
 src/backend/access/hash/hashsearch.c          |   2 +-
 src/backend/access/hash/hashsort.c            |   2 +-
 src/backend/access/heap/pruneheap.c           |   2 +-
 src/backend/access/heap/vacuumlazy.c          |  11 +-
 src/backend/access/heap/visibilitymap.c       |   2 +-
 src/backend/access/index/genam.c              |   1 +
 src/backend/access/nbtree/nbtdedup.c          |   2 +-
 src/backend/access/nbtree/nbtinsert.c         |   2 +-
 src/backend/access/nbtree/nbtpage.c           |   1 +
 src/backend/access/nbtree/nbtsearch.c         |   2 +-
 src/backend/access/spgist/spgdoinsert.c       |   9 +-
 src/backend/access/spgist/spginsert.c         |   2 +-
 src/backend/access/spgist/spgscan.c           |   2 +-
 src/backend/access/spgist/spgvacuum.c         |   2 +-
 src/backend/access/transam/README             |   2 +-
 src/backend/access/transam/README.parallel    |   2 +-
 src/backend/access/transam/generic_xlog.c     |   2 +-
 src/backend/access/transam/parallel.c         |  77 +--
 src/backend/access/transam/slru.c             |   2 +-
 src/backend/access/transam/twophase.c         |   1 +
 src/backend/access/transam/xlog.c             |  14 +-
 src/backend/access/transam/xlogfuncs.c        |  12 +-
 src/backend/access/transam/xlogrecovery.c     | 103 ++-
 src/backend/access/transam/xlogwait.c         |  39 +-
 src/backend/backup/basebackup_throttle.c      |  18 +-
 src/backend/bootstrap/bootparse.y             |   2 +-
 src/backend/commands/async.c                  | 152 ++---
 src/backend/commands/copyfromparse.c          |  11 +-
 src/backend/commands/vacuum.c                 |  13 +-
 src/backend/executor/nodeAppend.c             |  23 +-
 src/backend/executor/nodeGather.c             |  11 +-
 src/backend/ipc/Makefile                      |  19 +
 src/backend/ipc/README.md                     | 260 ++++++++
 src/backend/ipc/interrupt.c                   | 431 ++++++++++++
 src/backend/ipc/meson.build                   |   6 +
 src/backend/ipc/signal_handlers.c             | 160 +++++
 src/backend/libpq/auth.c                      |   9 +-
 src/backend/libpq/be-secure-gssapi.c          |  16 +-
 src/backend/libpq/be-secure-openssl.c         |   7 +-
 src/backend/libpq/be-secure.c                 |  62 +-
 src/backend/libpq/pqcomm.c                    |  37 +-
 src/backend/libpq/pqmq.c                      |  30 +-
 src/backend/meson.build                       |   1 +
 src/backend/postmaster/Makefile               |   1 -
 src/backend/postmaster/autovacuum.c           | 151 ++---
 src/backend/postmaster/auxprocess.c           |   2 +-
 src/backend/postmaster/bgworker.c             | 173 ++---
 src/backend/postmaster/bgwriter.c             |  51 +-
 src/backend/postmaster/checkpointer.c         | 191 +++---
 src/backend/postmaster/interrupt.c            | 108 ---
 src/backend/postmaster/meson.build            |   1 -
 src/backend/postmaster/pgarch.c               | 100 ++-
 src/backend/postmaster/postmaster.c           |  57 +-
 src/backend/postmaster/startup.c              | 104 ++-
 src/backend/postmaster/syslogger.c            |  37 +-
 src/backend/postmaster/walsummarizer.c        |  83 ++-
 src/backend/postmaster/walwriter.c            |  46 +-
 .../libpqwalreceiver/libpqwalreceiver.c       |   1 -
 .../replication/logical/applyparallelworker.c | 146 ++---
 src/backend/replication/logical/launcher.c    | 123 ++--
 .../replication/logical/sequencesync.c        |   6 +-
 src/backend/replication/logical/slotsync.c    |  90 +--
 src/backend/replication/logical/tablesync.c   |  38 +-
 src/backend/replication/logical/worker.c      |  49 +-
 src/backend/replication/slot.c                |  37 +-
 src/backend/replication/syncrep.c             |  42 +-
 src/backend/replication/walreceiver.c         |  56 +-
 src/backend/replication/walreceiverfuncs.c    |   3 +-
 src/backend/replication/walsender.c           | 228 ++++---
 src/backend/storage/aio/aio.c                 |   2 +-
 src/backend/storage/aio/aio_io.c              |   2 +-
 src/backend/storage/aio/method_worker.c       |  71 +-
 src/backend/storage/buffer/bufmgr.c           |  21 +-
 src/backend/storage/buffer/freelist.c         |  27 +-
 src/backend/storage/ipc/Makefile              |   1 -
 src/backend/storage/ipc/dsm_impl.c            |   4 +-
 src/backend/storage/ipc/ipc.c                 |  12 +-
 src/backend/storage/ipc/latch.c               | 389 -----------
 src/backend/storage/ipc/meson.build           |   1 -
 src/backend/storage/ipc/procarray.c           |  22 +-
 src/backend/storage/ipc/procsignal.c          | 225 +------
 src/backend/storage/ipc/shm_mq.c              | 127 ++--
 src/backend/storage/ipc/signalfuncs.c         |  14 +-
 src/backend/storage/ipc/sinval.c              |  68 +-
 src/backend/storage/ipc/sinvaladt.c           |  22 +-
 src/backend/storage/ipc/standby.c             |  43 +-
 src/backend/storage/ipc/waiteventset.c        | 400 ++++++------
 src/backend/storage/lmgr/condition_variable.c |  35 +-
 src/backend/storage/lmgr/predicate.c          |   9 +-
 src/backend/storage/lmgr/proc.c               | 148 ++---
 src/backend/storage/smgr/smgr.c               |   4 +-
 src/backend/storage/sync/sync.c               |   6 +-
 src/backend/tcop/backend_startup.c            |   8 +
 src/backend/tcop/postgres.c                   | 615 +++++++++---------
 src/backend/utils/adt/jsonpath_gram.y         |   2 +-
 src/backend/utils/adt/mcxtfuncs.c             |  11 +-
 src/backend/utils/adt/misc.c                  |  25 +-
 src/backend/utils/adt/timestamp.c             |   4 +-
 src/backend/utils/error/elog.c                |   1 -
 src/backend/utils/init/globals.c              |  23 -
 src/backend/utils/init/miscinit.c             |  78 +--
 src/backend/utils/init/postinit.c             |  42 +-
 src/backend/utils/misc/timeout.c              |   7 -
 src/backend/utils/mmgr/mcxt.c                 |  24 +-
 contrib/pg_prewarm/autoprewarm.c              |  63 +-
 contrib/postgres_fdw/connection.c             |  21 +-
 contrib/postgres_fdw/postgres_fdw.c           |   4 +-
 doc/src/sgml/bgworker.sgml                    |  32 +-
 doc/src/sgml/oauth-validators.sgml            |   2 +-
 doc/src/sgml/sources.sgml                     |  11 +-
 src/test/isolation/isolationtester.c          |   2 +-
 src/test/modules/test_shm_mq/setup.c          |  15 +-
 src/test/modules/test_shm_mq/test.c           |  16 +-
 src/test/modules/test_shm_mq/test_shm_mq.h    |   2 +
 src/test/modules/test_shm_mq/worker.c         |  12 +-
 src/test/modules/worker_spi/worker_spi.c      |  45 +-
 src/tools/pgindent/typedefs.list              |   3 +-
 163 files changed, 3537 insertions(+), 3442 deletions(-)
 create mode 100644 src/include/ipc/interrupt.h
 rename src/include/{postmaster/interrupt.h => ipc/signal_handlers.h} (82%)
 create mode 100644 src/backend/ipc/Makefile
 create mode 100644 src/backend/ipc/README.md
 create mode 100644 src/backend/ipc/interrupt.c
 create mode 100644 src/backend/ipc/meson.build
 create mode 100644 src/backend/ipc/signal_handlers.c
 delete mode 100644 src/backend/postmaster/interrupt.c
 delete mode 100644 src/backend/storage/ipc/latch.c

diff --git a/src/include/Makefile b/src/include/Makefile
index ac673f4cf17..c474d6fbe3c 100644
--- a/src/include/Makefile
+++ b/src/include/Makefile
@@ -28,6 +28,7 @@ SUBDIRS = \
 	executor \
 	fe_utils \
 	foreign \
+	ipc \
 	jit \
 	lib \
 	libpq \
diff --git a/src/include/access/parallel.h b/src/include/access/parallel.h
index 60f857675e0..6d57c310239 100644
--- a/src/include/access/parallel.h
+++ b/src/include/access/parallel.h
@@ -55,7 +55,6 @@ typedef struct ParallelWorkerContext
 	shm_toc    *toc;
 } ParallelWorkerContext;
 
-extern PGDLLIMPORT volatile sig_atomic_t ParallelMessagePending;
 extern PGDLLIMPORT int ParallelWorkerNumber;
 extern PGDLLIMPORT bool InitializingParallelWorker;
 
@@ -72,7 +71,6 @@ extern void WaitForParallelWorkersToFinish(ParallelContext *pcxt);
 extern void DestroyParallelContext(ParallelContext *pcxt);
 extern bool ParallelContextActive(void);
 
-extern void HandleParallelMessageInterrupt(void);
 extern void ProcessParallelMessages(void);
 extern void AtEOXact_Parallel(bool isCommit);
 extern void AtEOSubXact_Parallel(bool isCommit, SubTransactionId mySubId);
diff --git a/src/include/access/xlogrecovery.h b/src/include/access/xlogrecovery.h
index 2842106b285..7564d23cf7b 100644
--- a/src/include/access/xlogrecovery.h
+++ b/src/include/access/xlogrecovery.h
@@ -15,7 +15,6 @@
 #include "catalog/pg_control.h"
 #include "lib/stringinfo.h"
 #include "storage/condition_variable.h"
-#include "storage/latch.h"
 #include "utils/timestamp.h"
 
 /*
@@ -77,23 +76,6 @@ typedef struct XLogRecoveryCtlData
 	 */
 	bool		SharedPromoteIsTriggered;
 
-	/*
-	 * recoveryWakeupLatch is used to wake up the startup process to continue
-	 * WAL replay, if it is waiting for WAL to arrive or promotion to be
-	 * requested.
-	 *
-	 * Note that the startup process also uses another latch, its procLatch,
-	 * to wait for recovery conflict. If we get rid of recoveryWakeupLatch for
-	 * signaling the startup process in favor of using its procLatch, which
-	 * comports better with possible generic signal handlers using that latch.
-	 * But we should not do that because the startup process doesn't assume
-	 * that it's waken up by walreceiver process or SIGHUP signal handler
-	 * while it's waiting for recovery conflict. The separate latches,
-	 * recoveryWakeupLatch and procLatch, should be used for inter-process
-	 * communication for WAL replay and recovery conflict, respectively.
-	 */
-	Latch		recoveryWakeupLatch;
-
 	/*
 	 * Last record successfully replayed.
 	 */
diff --git a/src/include/commands/async.h b/src/include/commands/async.h
index 3baae7cb8dc..acd9afbcc4b 100644
--- a/src/include/commands/async.h
+++ b/src/include/commands/async.h
@@ -13,11 +13,8 @@
 #ifndef ASYNC_H
 #define ASYNC_H
 
-#include <signal.h>
-
 extern PGDLLIMPORT bool Trace_notify;
 extern PGDLLIMPORT int max_notify_queue_pages;
-extern PGDLLIMPORT volatile sig_atomic_t notifyInterruptPending;
 
 extern Size AsyncShmemSize(void);
 extern void AsyncShmemInit(void);
@@ -40,9 +37,6 @@ extern void AtSubCommit_Notify(void);
 extern void AtSubAbort_Notify(void);
 extern void AtPrepare_Notify(void);
 
-/* signal handler for inbound notifies (PROCSIG_NOTIFY_INTERRUPT) */
-extern void HandleNotifyInterrupt(void);
-
 /* process interrupts */
 extern void ProcessNotifyInterrupt(bool flush);
 
